package activedirectory

import (
	cnsma "git.loafle.net/commons_go/network_service_matcher/activedirectory"
	configM "git.loafle.net/overflow/overflow_commons_go/modules/config/model"
	"git.loafle.net/overflow/overflow_probe_container_network/crawler"
	"git.loafle.net/overflow/overflow_probe_container_network/crawler/impl/health"
)

type ActiveDirectoryHealthCrawler struct {
	health.SocketHeahthCrawler
}

func (r *ActiveDirectoryHealthCrawler) Name() string {
	return "ACTIVEDIRECTORY_HEALTH_CRAWLER"
}

func (r *ActiveDirectoryHealthCrawler) InternalGet(config *configM.Config) (map[string]string, error) {

	rss, err := r.CheckHeahth(config)
	if err != nil {
		return nil, err
	}
	return rss, nil
}

func NewCrawler() crawler.Crawler {
	ad := &ActiveDirectoryHealthCrawler{}
	ad.Internal = ad
	ad.SetMatcher(cnsma.NewMatcher())
	return ad
}
