package activedirectory

import (
	"encoding/json"
	"log"
	"testing"
	"time"

	"git.loafle.net/overflow/overflow_probe_container_network/crawler"
)

func setConfig() crawler.Crawler {

	r := NewCrawler().*

	m := make(map[string]interface{}, 0)

	m["ip"] = "192.168.1.1"
	m["port"] = "389"
	m["portType"] = "tcp"
	m["ssl"] = false

	r.PutConfig("ad", m)

	return r
}

func TestMatch(t *testing.T) {
	// test config
	r := setConfig()

	out := param.Output{}
	r.Get("ad", &out)

	var check bool
	json.Unmarshal(out.Data, &check)

	assert.Equal(t, true, check)
}

func start() {
	r := setConfig()

	of_rpc.AddDelegate("ad", r)
	err := of_rpc.StartJSONRPC()
	if err != nil {
		log.Fatal(err)
	}
}

func TestRPC(t *testing.T) {
	go start()
	time.Sleep(2 * time.Second)

	in := param.Input{
		Name: "ad",
		Id:   "ad",
	}

	result, err := client.InvokeJSONRPCGet("50000", in)

	if err != nil {
		t.Fatal(err)
	}

	var check bool
	json.Unmarshal(result.Data, &check)
	assert.Equal(t, true, check)
}
